const nodemailer = require('nodemailer');
const config = require('./config')
const fs = require('fs');

const transporter = nodemailer.createTransport({
    host: "mail.privateemail.com",
    auth: {
        user: config.mailerEmail,
        pass: config.mailerPassword
    }
});

class Mailer {

    async sendWelcomeSubAdminMail(toMail, name, username, email, role, password) {
        try {
            await fs.readFile(__dirname + '/mailTemplates/welcomeSubAdmin.html', 'utf8', function (err, file) {
                if (err) {
                    console.log('ERROR -> read welcomeSubAdmin.html  file !', err);
                    throw err
                } else {
                    let subject = `Tekoto - Message`,
                        message
                    message = file;
                    message = message.replace("@@IMAGE_LOGO@@", config.colorLogoLink);
                    message = message.replace("@@NAME@@", name);
                    message = message.replace("@@USERNAME@@", username);
                    message = message.replace("@@EMAIL@@", email);
                    message = message.replace("@@ROLE@@", role);
                    message = message.replace("@@PASSWORD@@", password);
                    message = message.replace("@@LINK@@", config.adminPanelLink);
                    let mailOptions = {
                        from: config.mailerEmail,
                        to: toMail,
                        subject: subject,
                        html: message
                    };
                    transporter.sendMail(mailOptions, function (error, info) {
                        if (error) {
                            console.log(error);
                            throw error
                        } else {
                            console.log('Email sent: ' + JSON.stringify(info));
                        }
                    });
                }
            })
        } catch (error) {
            console.log(error)
        }
    }
    async sendServiceProviderMail(name, toMail, phone_number, provider_type, password) {
        try {
            await fs.readFile(__dirname + '/mailTemplates/welcomeServiceProvider.html', 'utf8', function (err, file) {
                if (err) {
                    console.log('ERROR -> read welcomeServiceProvider.html  file !', err);
                    throw err
                } else {
                    let subject = `Tekoto - Message`,
                        message
                    message = file;
                    message = message.replace("@@IMAGE_LOGO@@", config.colorLogoLink);
                    message = message.replace("@@NAME@@", name);
                    message = message.replace("@@PROVIDER_TYPE@@", provider_type);
                    message = message.replace("@@PHONE_NUMBER@@", phone_number);
                    message = message.replace("@@EMAIL@@", toMail);
                    message = message.replace("@@PASSWORD@@", password);
                    let mailOptions = {
                        from: config.mailerEmail,
                        to: toMail,
                        subject: subject,
                        html: message
                    };
                    transporter.sendMail(mailOptions, function (error, info) {
                        if (error) {
                            console.log(error);
                            throw error
                        } else {
                            console.log('Email sent: ' + JSON.stringify(info));
                        }
                    });
                }
            })
        } catch (error) {
            console.log(error)
        }
    }
}

module.exports = new Mailer()

