const CategoryHelper = require('../helpers/CategoryHelper')
const responseHelper = require('../../utils/responseHelper')
/**
 * This Category class get Category related APIs
 */

class Category {

    /**
     * Get Category list API
     * @param {string} name  search name
     * @returns success response with All Category details
     * @date 2022-08-23
     */

    async getCategoryList(req, res) {
        try {
            let response = await CategoryHelper.getCategoryList(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Category, response.data, '', response.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Category);
        }
    }
}

module.exports = new Category();