const CommonHelper = require('../helpers/CommonHelper')
const CommonValidator = require('../validators/CommonValidator')
const responseHelper = require('../../utils/responseHelper')
/**
 * This Common class get Common related APIs
 */

class Common {
    /**
     * Get Common list API
     * @param {string} name  search name
     * @returns success response with All Common details
     * @date 2022-08-23
     */

    async addRemoveFavorites(req, res) {
        try {
            await CommonValidator.addRemoveFavoritesValidator(req.body);
            let result = await CommonHelper.addRemoveFavorites(req.body);

            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

    async addRating(req, res) {
        try {
            await CommonValidator.addRatingValidator(req.body);
            let result = await CommonHelper.addRating(req.body);

            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

    async addComment(req, res) {
        try {
            await CommonValidator.addCommentValidator(req.body);
            let result = await CommonHelper.addComment(req.body);

            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }



    async getPaymentOption(req, res) {
        try {
            let result = await CommonHelper.getPaymentOption(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

    async getPaymentToken(req, res) {
        try {
            let result = await CommonHelper.getPaymentToken(req.body);
            console.log(result.data);
            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

}

module.exports = new Common();