const RecipeHelper = require('../helpers/RecipeHelper')
const RecipeValidator = require('../validators/RecipeValidator')
const responseHelper = require('../../utils/responseHelper')
/**
 * This Recipe class get Recipe related APIs
 */

class Recipe {
    /**
     * Get Recipe list API
     * @param {string} name  search name
     * @returns success response with All Recipe details
     * @date 2022-08-23
     */

    async addRecipe(req, res) {
        try {
            await RecipeValidator.addRecipeValidator(req.body);
            let result = await RecipeHelper.addRecipe(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

    async addMeal(req, res) {
        try {
            await RecipeValidator.addMealValidator(req.body);
            let result = await RecipeHelper.addMeal(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }

    async getMeal(req, res) {
        try {
            await RecipeValidator.getMealValidator(req.body);
            let result = await RecipeHelper.getMeal(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Section, result.data, '', result.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Section);
        }
    }
}

module.exports = new Recipe();