const SettingHelper = require('../helpers/SettingHelper')
const responseHelper = require('../../utils/responseHelper')
/**
 * This Setting class get Setting related APIs
 */

class Setting {

    /**
     * Get Setting list API
     * @returns success response with All Setting details
     * @date 2022-08-23
     */

    async getSettingList(req, res) {
        try {
            let response = await SettingHelper.getSettingList(req.body);
            responseHelper.success(res, 'SUCCESS', req.headers.Setting, response.data, '', response.total);
        } catch (error) {
            responseHelper.error(res, error, req.headers.Setting);
        }
    }
}

module.exports = new Setting();