const promise = require('bluebird')
const dateHelper = require('../../utils/dateHelper')
const db = require('../../utils/db')
const config = require('../../utils/config')
const multer = require('multer')
const md5 = require('md5');




class UserHelper {
    async getProfile(body) {
        try {
            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image ', where = ` 1=1 AND id='${body.id}'`;
            let datas = await db.select('user', selectParams, where);

            let data = '';
            await datas.forEach(function (row) {

                data = row;
            });
            return { data };

        } catch (error) {
            return promise.reject(error)
        }
    }

    async updateProfile(body) {
        try {
            let requestData = {};
            let email = body.email ? body.email : '';
            let mobile = body.mobile ? body.mobile : '';
            let name = body.name ? body.name : '';
            let address = body.address ? body.address : '';

            if (address) {
                requestData['address'] = address;
            }

            if (email) {
                requestData['email'] = email;
            }
            if (mobile) {
                requestData['mobile'] = mobile;
            }
            if (name) {
                console.log(requestData);
                requestData['name'] = name;
            }


            let where = `id=${body.id}`;
            await db.update('user', where, requestData)

            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image';
            let whereGetVideoWatch = `id= ${body.id}`;
            let user = await db.getById('user', selectParams, whereGetVideoWatch);
            let data = user;
            return { data };

        } catch (error) {
            return promise.reject(error)
        }
    }

    async becomeChef(body) {
        try {
            let requestData = {};

            requestData['is_chef'] = "1";
            requestData['image'] = "chief.png";

            let where = `id=${body.user_id}`;
            await db.update('user', where, requestData)

            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image';
            let whereGetVideoWatch = `id= ${body.user_id}`;
            let user = await db.getById('user', selectParams, whereGetVideoWatch);
            let data = user;
            return { data };

        } catch (error) {
            return promise.reject(error)
        }
    }

    async register(body) {
        try {

            let email = body.email ? body.email : '';
            let mobile = body.mobile ? body.mobile : '';
            let name = body.name ? body.name : '';
            let password = body.password ? body.password : '';
            let userId = '';

            let where = `email= '${email}'`;
            let selectParams = '*';
            let user = await db.getById('user', selectParams, where);


            let where_mobile = `mobile= '${mobile}'`;
            let userMobile = await db.getById('user', selectParams, where_mobile);

            if (user.id || userMobile.id) {
                userId = user.id ? userMobile.id : 0;
            } else {
                let requestData = {
                    name: name,
                    mobile: mobile,
                    email: email,
                    type: 1,
                    password: md5(password),
                };


                let lastId = await db.insert('user', requestData)
                userId = lastId;
            }

            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let whereUser = `id= ${userId}`;
            let selectParamsUser = '*, concat("' + image_path + '", image) as image ';
            let userData = await db.getById('user', selectParamsUser, whereUser);
            delete (userData.password);
            let data = userData;
            return { data };

        } catch (error) {
            console.log('error')
            return promise.reject(error)
        }
    }
    async login(body) {
        try {

            let email = body.email ? body.email : '';
            let type = body.type ? body.type : '';
            let mobile = body.mobile ? body.mobile : '';
            let name = body.name ? body.name : '';
            let password = body.password ? body.password : '';
            let userId = '';
            let message = 'LOGIN_SUCCESS_FULLY';
            if (type == '1') {
                let where = `email= '${email}' AND password= '${md5(password)}'`;
                let selectParams = '*';
                let user = await db.getById('user', selectParams, where);

                if (user.id) {
                    const image_path = config.IMAGE_BASE_PATH + 'user/';
                    let whereUser = `id= ${user.id}`;
                    let selectParamsUser = '*, concat("' + image_path + '", image) as image ';
                    let userData = await db.getById('user', selectParamsUser, whereUser);
                    let data = userData;

                    return { data, message };
                } else {
                    console.log('returnData');
                    let data = [];
                    let message = 'EMAIL_AND_PASSWORD_WRONG';
                    return { data, message };
                }
            }

            if (type == '3' || type == '2') {

                let where = `email= '${email}'`;
                let selectParams = '*';
                let user = await db.getById('user', selectParams, where);


                if (user.id) {
                    userId = user.id;
                } else {
                    let requestData = {
                        name: name,
                        mobile: mobile,
                        email: email,
                        type: type,
                        image: 'user.png',
                    };
                    let lastId = await db.insert('user', requestData)
                    userId = lastId;
                }

                const image_path = config.IMAGE_BASE_PATH + 'user/';
                let whereUser = `id= ${userId}`;
                let selectParamsUser = '*, concat("' + image_path + '", image) as image ';
                let userData = await db.getById('user', selectParamsUser, whereUser);

                let data = userData;
                return { data, message };
            } else if (type == 4) {
                let where = `mobile= ${mobile}`;
                let selectParams = '*';
                let user = await db.getById('user', selectParams, where);

                if (user.id) {
                    userId = user.id;
                } else {
                    let requestData = {
                        name: name,
                        mobile: mobile,
                        email: email,
                        type: 3,
                        image: 'user.png',
                    };
                    let lastId = await db.insert('user', requestData)
                    userId = lastId;
                }

                const image_path = config.IMAGE_BASE_PATH + 'user/';
                let whereUser = `id= ${userId}`;
                let selectParamsUser = '*, concat("' + image_path + '", image) as image ';
                let userData = await db.getById('user', selectParamsUser, whereUser);
                let data = userData;
                return { data, message };
            }

        } catch (error) {
            console.log('error')
            return promise.reject(error)
        }
    }

    async imageUpload(req) {
        try {


            let image = req.file ? req.file : '';

            if (image == '') {
                let error = { param: 'image', type: 'any.required', message: '"image" is required' };
                return promise.reject(error)
            }

            let requestData = {
                image: req.file.filename
            };

            let where = `id=${req.body.id}`;
            await db.update('user', where, requestData)

            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image';
            let whereGetUser = `id= ${req.body.id}`;
            let user = await db.getById('user', selectParams, whereGetUser);
            let data = user;
            return { data };

        } catch (error) {
            return promise.reject(error)
        }
    }

    async mediaUpload(req) {
        try {
            let image = req.file.filename;
            const image_path = config.IMAGE_BASE_PATH + 'recipe/' + image;

            let data = image_path;
            return { data };

        } catch (error) {
            return promise.reject(error)
        }
    }

}

module.exports = new UserHelper()